// 1) Definování proměnných a inicializace knihoven
// Teploměr
int termPin = 0;      
int termNom = 10000;  
int refTep = 25;      
int beta = 3977;      
int rezistor = 10000;
float teplota1 = 0;
// Motor
#include <AccelStepper.h>
int motorRychlost = 500;
float prutok = 0.052*motorRychlost-2;
AccelStepper Motor(1, 3, 4);
// RGB LED dioda
int R_Pin = 9;
int G_Pin = 8;
int B_Pin = 7;
// Fotodioda
#define pH_pin A3
float pH_value = 7;
#include <Average.h>
Average<float> ave(10);
// Displej
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Fonts/FreeSans9pt7b.h>
#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 64
#define OLED_RESET    -1
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);
// Buetooth
#include <SoftwareSerial.h>
SoftwareSerial Bluetooth(10,11);
String State="";
// Časové intervaly
unsigned long lastMillis1;
unsigned long lastMillis2;
unsigned long lastMillis3;
unsigned long lastMillis4;
// 2) Nastavení smyčky setup, která proběhne pouze jednou
void setup() {
  Serial.begin(9600);
  analogReference(EXTERNAL);
  Motor.setMaxSpeed(1000);
  Motor.setSpeed(motorRychlost);
  pinMode(R_Pin, OUTPUT);
  pinMode(G_Pin, OUTPUT);
  pinMode(B_Pin, OUTPUT);
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.setFont(&FreeSans9pt7b);
  Bluetooth.begin(9600);
}
// Funkce na zjištění teploty z teplotního čidla (NTC termistor)
void teplota() {
  float napeti;
  napeti = analogRead(termPin);
  napeti = 1023 / napeti - 1;
  napeti = rezistor / napeti;
  float teplota;
  teplota = napeti / termNom;         
  teplota = log(teplota);             
  teplota /= beta;                    
  teplota += 1.0 / (refTep + 273.15); 
  teplota = 1.0 / teplota;            
  teplota -= 273.15;
  teplota1 = teplota;                
}
// Funkce na spuštění svícení RGB LED diody
void setColor(int R, int G, int B) {
#ifdef COMMON_ANODE
  R = 255 - R;
  G = 255 - G;
  B = 255 - B;
#endif
  analogWrite(R_Pin, R);
  analogWrite(G_Pin, G);
  analogWrite(B_Pin, B);
}
// Funkce na zjištění hodnoty pH
void setValue() {
  float value = analogRead(pH_pin)-20;
  ave.push(value);
  float A=log10(119.64/ave.mean());
  float pH_status=-23246*sq(A)+138.99*A+7.8803;
  pH_value = pH_status;
}
// Funkce vykreslení na displeji
void vykresli() {
  display.clearDisplay();
  display.setTextColor(WHITE);
  display.setTextSize(1);
  // 1) Průtok
  display.setCursor(0,15);
  display.print(prutok);
  display.print(" ml/min");
  // 2) Teplota
  display.setCursor(0, 35);
  display.print(teplota1);
  display.print(" ");
  display.print("°");
  display.print("C");
  // 3) pH
  display.setCursor(0, 55);
  if (pH_value >= 6 && pH_value <= 8) {
    display.print(pH_value);
  } else if (pH_value >= 0 && pH_value <= 14){
    display.print("POZOR");
  } else {
    display.print("CHYBA");
  }
}
// Funkce výpočtu pH, teploty a vykreselní na displej
void doStuff() {
  Motor.runSpeed();
  if ((millis() - lastMillis1) >= 1000 ) {
    teplota();
    Motor.runSpeed();
    lastMillis1 = millis();
  }
  Motor.runSpeed();
  if ((millis() - lastMillis2) >= 1000 ) {
    setColor(182, 255, 0);
    Motor.runSpeed();
    lastMillis2 = millis();    
  }
  Motor.runSpeed();
  if ((millis()- lastMillis3) >= 1000) {
    setValue();
    Motor.runSpeed();
    lastMillis3 = millis();
  }
  Motor.runSpeed();
  if ((millis()- lastMillis4) >= 5000) {
    vykresli();
    Motor.runSpeed();
    display.display();
    Motor.runSpeed();
    lastMillis4 = millis();
  }
  Motor.runSpeed();
}
// Smyčka loop
void loop() {
  delayMicroseconds(1);
  if (Bluetooth.available()>0) {
    State=Bluetooth.readString();
  } else {
    Motor.setSpeed(motorRychlost);
    Motor.runSpeed();
    doStuff();
    Motor.runSpeed();
  }
  int Speed=State.toInt();
  prutok = 0.052*Speed-2;
  Motor.setSpeed(Speed);
  Motor.runSpeed();
  doStuff();
  Motor.runSpeed();  
}
